program Template_SDL;

{******************************************************************}
{                                                                  }
{       DGL SDL-Template - modified                                }
{       http://www.delphigl.com                                    }
{       Florian Sievert alias Phobeus                              }
{       Modified by :                                              }
{                     Thomas Lahmer alias Tomok                    }
{                     Kevin Fleischer alias Flash                  }
{                                                                  }
{   Basierend auf den OpenGL-Template von                          }
{     Jan Horn - In Memorial...                                    }
{     http://www.sulaco.co.za                                      }
{                                                                  }
{   Basierend auf den SDL-Beispielen von                           }
{     Dominique Louis <Dominique@SavageSoftware.com.au>            }
{                                                                  }
{                                                                  }
{ Herkunft(Orginal)                                                }
{ --------------                                                   }
{ http://www.delphigl.com                                          }
{                                                                  }
{ Diese Daten stammen von der DGL-Community einem Verbund von      }
{ deutschsprachigen Delphi-Programmierern mit einem besonderen     }
{ Augenmerk auf die OpenGL-Programmierung. Wir mchten unser Wissen}
{ und Erfahrung gerne mit anderen Teilen und uns mit anderen       }
{ Programmieren austauschen. Egal, ob Anfnger, Fortgeschrittener  }
{ oder Profi, wir freuen uns ber jedes neue Mitglied, dass aktiv  }
{ am Community-Leben teilnimmt. Neugierung geworden und Lust auf   }
{ mehr Source-Code? Dann statte uns einen Besuch ab unter:         }
{                                                                  }
{ http://www.delphigl.com/                                         }
{                                                                  }
{ Wenn Du diesen Source Code oder Teile davon verwendest, wrde    }
{ sich DGL sehr freuen, wenn Du uns Credits geben knntest. Egal,  }
{ ob in der Text-Datei oder im eigentlichen Programm. Der Autor    }
{ dieses Source Code, wird sich in jedem Fall freuen, wenn sein    }
{ Name auch in anderen Projekten erscheint. Seit so fair und dankt }
{ dem Autor auf dieser Weise dafr. Zudem profitiert auch die DGL  }
{ Community davon, wenn Du zeigst, dass Du ein Mitglied bist.      }
{ Nur durch ein gutes Ansehen lassen sich auch gemeinsame          }
{ Interessen verwirklichen. Fragen? Zgere nicht uns zu            }
{ kontaktieren!                                                    }
{                                                                  }
{  Bitte beachtet in Euren Credits auch Dritte! Danke!             }
{                                                                  }
{ Lizens                                                           }
{ -----------                                                      }
{                                                                  }
{ The contents of this file are used with permission, subject to   }
{ the Mozilla Public License Version 1.1 (the "License"); you may  }
{ not use this file except in compliance with the License. You may }
{ obtain a copy of the License at                                  }
{ http://www.mozilla.org/MPL/MPL-1.1.html                          }
{                                                                  }
{ Software distributed under the License is distributed on an      }
{ "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either expressed or }
{ implied. See the License for the specific language governing     }
{ rights and limitations under the License.                        }
{                                                                  }
{ Beschreibung                                                     }
{ -----------                                                      }
{  Dieses Template zeigt Euch, wie Ihr mit Hilfe von SDL OpenGL    }
{  initalisieren und nutzen knnt.                                 }
{                                                                  }
{ Bentigt                                                         }
{ --------                                                         }
{   SDL-DLLs in einem Systempfad oder im Programmverzeichnis       }
{                                                                  }
{   Aktuelle SDL.Runtime                                           }
{       http://www.libsdl.org                                      }
{   Aktueller DGL-OpenGL-Header                                    }
{       http://www.delphigl.com/                                   }
{   oder neuste DGL-SDK                                            }
{                                                                  }
{                                                                  }
{ Notizen                                                          }
{ -----------------                                                }
{                                                                  }
{                                                                  }
{                                                                  }
{                                                                  }
{                                                                  }
{ History                                                          }
{ ----------------                                                 }
{   2003-06-11  FS :   Erstellen dieses Templates                  }
{   2005-03-21  Tomok: Template auf DGLOpenGL.pas umgestellt       }
{   2005-09-15  Flash: Quit_App() Aufruf am Programmende           }
{                                                                  }
{ Kontakt                                                          }
{ ----------------                                                 }
{  FS                                                              }
{     Florian Sievert alias Phobeus                                }
{     E-Mail : Phobeus@TheChaosCompany.Net                         }
{     Website: http://www.delphigl.com                             }
{                                                                  }
{******************************************************************}

{$R *.res}

Uses
    SysUtils, Classes,Windows,
    SDL in 'SDL.pas',
    dglOpenGL,
    Logger in 'Logger.pas';

CONST
    WINDOWS_CAPTION     =       'http://www.delphigl.com/ .:. SDL-Template';

    SCREEN_WIDTH        = 800;
    SCREEN_HEIGHT       = 600;
    SCREEN_BPP          = 32;

    FPS_INTERVAL        = 1000;               // Jede Sekunde FPS berechnen

    INVALID_MODULEHANDLE = 0;

var
    surface     : PSDL_Surface;

    videoInfo   : PSDL_VideoInfo;
    videoflags  : Uint32;

    done        : Integer;                    // Programmstatus : 0 Default -1 Programmabruch

    FPSCount    : LongInt;

    GLHandle: HINST;
    GLUHandle: HINST;

//----------------------------------------------------------------------------
// Konvertiert Integers in Strings
//----------------------------------------------------------------------------
function IntToStr(Num : Integer) : String;
begin
  Str(Num, result);
end;

//----------------------------------------------------------------------------
// Zeichnen der Szene
//----------------------------------------------------------------------------
procedure glDrawScene;
begin
  // Screen- und Tiefenbuffer bereinigen
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT );

  glLoadIdentity;
  glTranslatef( -1.5, 0.0, -6.0 );

  // Zeichne Dreieck
  glcolor3f(1,0,0);
  glBegin( GL_TRIANGLES );
    glVertex3f( 0.0, 1.0, 0.0 );
    glVertex3f( 1.0, -1.0, 0.0 );
    glVertex3f( -1.0, -1.0, 0.0 );
  glEnd;

  glTranslatef( 3.0, 0.0, 0.0 );

  // Zeichne ein Quadrat
  glcolor3f(0,1,0);  
  glBegin( GL_QUADS );
    glVertex3f( -1.0, 1.0, 0.0 );
    glVertex3f( 1.0, 1.0, 0.0 );
    glVertex3f( 1.0, -1.0, 0.0 );
    glVertex3f( -1.0, -1.0, 0.0 );
  glEnd;

  // Buffer-Wechseln ==> Anzeigen
  SDL_GL_SwapBuffers;
end;


//----------------------------------------------------------------------------
// Terminieren der SDL-Anwendung
//----------------------------------------------------------------------------
procedure Quit_App;
  procedure CloseOpenGL;
  begin
    if GLHandle <> INVALID_MODULEHANDLE then
    begin
      FreeLibrary(Cardinal(GLHandle));
      GLHandle := INVALID_MODULEHANDLE;
    end;

    if GLUHandle <> INVALID_MODULEHANDLE then
    begin
      FreeLibrary(Cardinal(GLUHandle));
      GLUHandle := INVALID_MODULEHANDLE;
    end;

//    ClearProcAddresses;
    ClearExtensions;
  end;
begin;
  // Freigeben der Ressourcen
  SDL_QUIT;
  CloseOpenGL;
  Halt(0);
end;

(******************************************************************************)
(******************************************************************************)
//  Events
(******************************************************************************)
(******************************************************************************)

//----------------------------------------------------------------------------
// Behandelt Grenvernderung des Fensters
//----------------------------------------------------------------------------
function glResizeWindow( width : integer; height : integer ) : Boolean;
begin
  // Verhindern von "Division by Zero"
  if ( height = 0 ) then height := 1;

  // Viewport und Projektions-Matrix aktualisieren
  glViewport( 0, 0, width, height );

  glMatrixMode( GL_PROJECTION );
    glLoadIdentity;
    gluPerspective( 45.0, width / height, 0.1, 100.0 );
  glMatrixMode( GL_MODELVIEW );

  // Rcksetzen der World-Matrix
  glLoadIdentity;

  // Vorgang erfolgreich
  result := true;
end;

//----------------------------------------------------------------------------
// Tastatur Eingaben verarbeiten
//----------------------------------------------------------------------------
procedure glHandleKeyPress( keysym : PSDL_keysym );
begin;
  case keysym.sym of
    SDLK_ESCAPE : done := -1;
  end;
end;

//----------------------------------------------------------------------------
// Timer-Event fr FPS-Berechnung
//----------------------------------------------------------------------------
function glTimer( interval : UInt32; param : Pointer ) : UInt32;
begin;
    SDL_WM_SetCaption(pChar( WINDOWS_CAPTION + ' ['+IntToStr(Round(FPSCount * 1000/FPS_INTERVAL))+' FPS]') , nil);
    FPSCount := 0;
    Result := interval;
end;

//----------------------------------------------------------------------------
// Reagieren auf Programm_Events
//----------------------------------------------------------------------------
procedure glHandleEvents;
var event       : TSDL_Event;
begin;
    // Verarbeiten der Events
    while ( SDL_PollEvent( @event ) = 1 ) do
    begin
      case event.type_ of

        // Beenden der Applikation
        SDL_QUITEV :
        begin
          Done := -1;
        end;

        // Taste wurde gedrckt
        SDL_KEYDOWN :
        begin
          glHandleKeyPress( @event.key.keysym );
        end;

        // Fenster-Gre hat sich verndert
        SDL_VIDEORESIZE :
        begin
          surface := SDL_SetVideoMode( event.resize.w, event.resize.h, SCREEN_BPP, videoflags );

          if ( surface = nil ) then
          begin
            Log.LogError('Surface bei Grennderung verloren: '+SDL_GetError,'EVENT_RESIZE' );
            Quit_App;
          end;

          glResizeWindow( event.resize.w, event.resize.h );
        end;
      end;
    end;
end;

(******************************************************************************)
(******************************************************************************)
//  Initalisierung
(******************************************************************************)
(******************************************************************************)

//----------------------------------------------------------------------------
// Die Daten eines Objektes.
//----------------------------------------------------------------------------
procedure Init_OpenGL;
begin;
    // Laden und Initalisieren von OpenGL
//    LoadOpenGL;


    InitOpenGL;

 //   ActivateRenderingContext(
    ReadExtensions;

    // Ausganswerte fr die State-Machine setzen
    glEnable(GL_TEXTURE_2D);	                // Aktiviert Texture Mapping
    glShadeModel(GL_SMOOTH);	                // Aktiviert weiches Shading
    glClearColor(0.0, 0.0, 0.0, 0.5);         // Bildschirm lschen (schwarz)
    glClearDepth(1.0);		                    // Depth Buffer Setup
    glEnable(GL_DEPTH_TEST);	                // Aktiviert Depth Testing
    glDepthFunc(GL_LEQUAL);	                  // Bestimmt den Typ des Depth Testing
    glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
                                              // Qualitativ bessere Koordinaten Interpolation
end;

//----------------------------------------------------------------------------
// Initialisierung von Simple DirectMedia Layer
//----------------------------------------------------------------------------
procedure Init_SDL;
begin;
  // Initalisieren vom Simple DirectMedia Layer
  if ( SDL_Init( SDL_INIT_VIDEO ) < 0 ) then
  begin
    Log.LogError('Initalisierung von SDL schlug fehl: '+SDL_GetError,'SDL_Init');
    Quit_App;
  end;

  // Information ber Grafikkarte einholen
  videoInfo := SDL_GetVideoInfo;
  if ( videoInfo = nil ) then
  begin
    Log.LogError('Grafikkarte liess sich nicht abfragen: '+SDL_GetError,'SDL_Init' );
    Quit_App;
  end;

  // Flags fr den SDL-Grafikmodus setzen
  videoFlags := SDL_OPENGL or                  // OpenGL-Untersttzung aktivieren
                SDL_DOUBLEBUF or               // Double Buffering aktivieren
                SDL_HWPALETTE;                 // Palette in Hardware speichern

  // Kann die Surface in den Speicher?
  if ( videoInfo.hw_available <> 0 ) then
    videoFlags := videoFlags or SDL_HWSURFACE
  else
    videoFlags := videoFlags or SDL_SWSURFACE;

  // Wird hardware blitting untersttzt?
  if ( videoInfo.blit_hw <> 0 ) then videoFlags := videoFlags or SDL_HWACCEL;

  // Setzen der OpenGL-Attribute
  SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 5 );
  SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 16 );
  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );

  // Fenstertitel festlegen
  SDL_WM_SetCaption( WINDOWS_CAPTION , nil);

  videoflags := videoFlags or SDL_RESIZABLE;    // Enable window resizing

  // Initalisierung der Surface
  surface := SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,videoflags );
  if ( surface = nil ) then
  begin
    Log.LogError('Erzeugen einer OpenGL-Zeichenflche schlug fehl: '+SDL_GetError,'SDL_Init' );
    Quit_App;
  end;

  // Initalisierung des Timers
  SDL_Init(SDL_INIT_TIMER);
end;


(******************************************************************************)
(******************************************************************************)
//  Hauptprogramm
(******************************************************************************)
(******************************************************************************)

begin
  // Initalisierung
  Init_SDL;
  Init_OpenGL;

  // Setzen eines Timers fr FPS-Berechnung
  SDL_AddTimer(1000,@glTimer,nil);

  // Anpassen der Fenstergre
  glResizeWindow( SCREEN_WIDTH, SCREEN_HEIGHT );

  // Eintritt in Main-Loop
  while ( Done <> -1 ) do
  begin
    glHandleEvents;
    glDrawScene;
    Inc(FPSCount);
  end;

  Quit_App;
end.
